#ifndef NOTIFIER_H
#define NOTIFIER_H

#include "StateListener.h"
#include<list>

<namespace>{

class State;

/**
 *
 */
class Notifier{

public:
    virtual void notifyEntry(State* s)=0;

    virtual void notifyExit(State* s)=0;

    virtual void notifyEvent(State* s,std::string ev)=0;

    virtual void addStateListener(StateListener* nm)=0;

    virtual void removeStateListener(StateListener* nm)=0;
};

/**
 * A basic implementation of the interface above.
 */
class NotifierImpl : public Notifier{
private:
    std::list<StateListener*> LISTENER;
    std::list<StateListener*>::iterator it;

public:
    void notifyEntry(State* s){
    	StateListener* j;
        for(it=LISTENER.begin();it!=LISTENER.end();it++){
        	j=*it;
        	j->stateEntered(s);
        };
    };

    void notifyExit(State* g){
    	StateListener* j;
		for(it=LISTENER.begin();it!=LISTENER.end();it++){
			j=*it;
			j->stateExited(g);
		};
    };

    void notifyEvent(State* s,std::string h){
    	StateListener* j;
		for(it=LISTENER.begin();it!=LISTENER.end();it++){
			j=*it;
			j->eventHandled(s,h);
		};
    };

    void addStateListener(StateListener* nm){
        LISTENER.push_back(nm);
    };

    void removeStateListener(StateListener* nm){
        LISTENER.remove(nm);
    };
};
}

#endif /*NOTIFIER_H*/
